/*************************************************************

  This is a simple demo of sending and receiving some data.
  Be sure to check out other examples!
 *************************************************************/

/* Fill-in information from Blynk Device Info here */
#define BLYNK_TEMPLATE_ID           "Template_ID"
#define BLYNK_TEMPLATE_NAME         "Quickstart Template"
#define BLYNK_AUTH_TOKEN            "Auth_token"

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT Serial


#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "WIFI_SSID";
char pass[] = "WIFI_PASSWORD";

BlynkTimer timer;

const int R = D1, G = D2, B = D3; // GPIO pin for LED
int wait_time = 0;

BLYNK_WRITE(V0) // Button 1
{
  int buttonState = param.asInt();
  if (buttonState == 1) {
    if(wait_time <= 30) { //first 30 seconds
    analogWrite(R, 255);
    analogWrite(G, 0);
    analogWrite(B, 0); 
    }
    else if(wait_time > 30 && wait_time <= 120) { //after 30 seconds till 2 minutes
    analogWrite(R, 0);
    analogWrite(G, 255);
    analogWrite(B, 0); 
    }
    else if(wait_time > 120 && wait_time <= 180) { //after 2 minutes till 3 minutes
    analogWrite(R, 255);
    analogWrite(G, 255);
    analogWrite(B, 0); 
    }
    else { // end
    analogWrite(R, 0);
    analogWrite(G, 0);
    analogWrite(B, 0); 
    Blynk.virtualWrite(V0, LOW); // Set button 1 to off
    }
    delay(950); // delay for about 1 second
  }
}

BLYNK_WRITE(V1) // Button 2
{
  int buttonState = param.asInt();
  if (buttonState == 1) {
    // your logic here
  }
}

BLYNK_WRITE(V2) // Button 3
{
  int buttonState = param.asInt();
  if (buttonState == 1) {
    //your logic here
  }
}

// This function is called every time the device is connected to the Blynk.Cloud
BLYNK_CONNECTED()
{
  // Change Web Link Button message to "Congratulations!"
  Blynk.setProperty(V3, "offImageUrl", "https://static-image.nyc3.cdn.digitaloceanspaces.com/general/fte/congratulations.png");
  Blynk.setProperty(V3, "onImageUrl",  "https://static-image.nyc3.cdn.digitaloceanspaces.com/general/fte/congratulations_pressed.png");
  Blynk.setProperty(V3, "url", "https://docs.blynk.io/en/getting-started/what-do-i-need-to-blynk/how-quickstart-device-was-made");
}

// This function sends Arduino's uptime every second to Virtual Pin 2.
void myTimerEvent()
{
  // You can send any value at any time.
  // Please don't send more that 10 values per second.
  Blynk.virtualWrite(V2, millis() / 1000);
}

void setup()
{
  // Debug console
  Serial.begin(115200);

  Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass);
  // You can also specify server:
  //Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass, "blynk.cloud", 80);
  //Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass, IPAddress(192,168,1,100), 8080);

  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
}

void loop()
{
  Blynk.run();
  timer.run();
  // You can inject your own code or combine it with other sketches.
  // Check other examples on how to communicate with Blynk. Remember
  // to avoid delay() function!
}

